/* ========================================
 *
 * Copyright YOUR COMPANY, THE YEAR
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 *
 * ========================================
*/
#include <device.h>

int secretInt = -1;		// Just to give it a value

//void isr_fcn(void);	// I removed the call to the function in isr_1.c
CY_ISR_PROTO(isr_fcn);	// Definition of an interrupt routine (System reference documentation)

void main()
{
    /* Place your initialization/startup code here (e.g. MyInst_Start()) */

	// These should all be cleared to start, but j.i.k.
//	CyGlobalIntDisable;
//	isr_1_ClearPending(); isr is not and was not initialized
//	isr_1_Stop();
	CyGlobalIntEnable; // May be enabled rather early
	
	secretInt = 4;
	
	// Trigger the interrupt
	cr1_Write(0x00);	CyDelayUs(100);
	cr1_Write(0x01);	CyDelayUs(100);
	cr1_Write(0x00);	CyDelayUs(100);
	
	// Right now the pending flag is set
	isr_1_ClearPending();	// and now it's cleared
	// Enable, then disable the interrupt
	isr_1_StartEx(isr_fcn);
//	isr_1_Stop();		// Stop() "removes Interrupt" the datasheet says
	isr_1_Disable();	// Disables and gives you the opportunity to enable it again
	
	
	// Enable global mask
	// Right now, isr_1 should be disabled and not pending
	// ** Interrupt will fire here ** 
	
	secretInt = 7;
	
	// Enable interrupt
//	isr_1_Start(); This is not enable, this is a new start
	isr_1_Enable();
	
	// Trigger Interrupt
	cr1_Write(0x01);
	
	
    for(;;)	{}
}

// Place breakpoints on ints, both will be hit
CY_ISR(isr_fcn)
{
	if (4 == secretInt)
	{
		int iShouldNotBeCalled = 1;
	}
	if (7 == secretInt)
	{
		int iShouldBeCalled = 1;
	}
}


/* [] END OF FILE */
